#version 430 core

in vec2 f_uv;

layout(location = 0) out vec4 o_color;

layout(location = 4) uniform sampler2D texture_color;
layout(location = 5) uniform float resolution;

float blur_size = 3.0f / resolution; // 1/ texturesize

const int num_blur_pixels_per_side = 31;
const vec2 blur_multiply_vec = vec2(1.0, 0.0);

const float kernel[32] = float[32](
	0.0068,
	0.0073,
	0.0079,
	0.0085,
	0.0091,
	0.0097,
	0.0103,
	0.0110,
	0.0116,
	0.0123,
	0.0130,
	0.0137,
	0.0144,
	0.0150,
	0.0157,
	0.0164,
	0.0170,
	0.0176,
	0.0183,
	0.0188,
	0.0194,
	0.0199,
	0.0204,
	0.0208,
	0.0212,
	0.0216,
	0.0219,
	0.0221,
	0.0223,
	0.0224,
	0.0225,
	0.0225
);

void main()
{
	vec4 avg_value = vec4(0.0, 0.0, 0.0, 0.0);
	avg_value += texture(texture_color, f_uv) * kernel[num_blur_pixels_per_side];

	for (int i = 1; i <= num_blur_pixels_per_side; i++) {

		int k = num_blur_pixels_per_side - i;
		avg_value += texture(texture_color, f_uv - i * blur_size * blur_multiply_vec) * kernel[k];         
		avg_value += texture(texture_color, f_uv + i * blur_size * blur_multiply_vec) * kernel[k];          
	}

	o_color = avg_value;
}