#version 430 core

in vec2 f_uv;

layout(location = 0) out vec4 o_color;

layout(location = 4) uniform sampler2D texture_color;
layout(location = 5) uniform sampler2D texture_glow_unblurred;
layout(location = 6) uniform sampler2D texture_glow_blurred;


float glow_intensity = 2.0f;

void main()
{
	vec4 glow_blurred = texture(texture_glow_blurred, f_uv);
	vec4 color = texture(texture_color, f_uv);
	vec4 glow_unblurred = texture(texture_glow_unblurred, f_uv);

	// Max col+col because gaussian filter will make objekts
	// centers brighter than object borders.. this just means
	// that the whole object should glow
	vec3 out_color_raw = max(color + glow_blurred * glow_intensity, glow_unblurred + glow_unblurred).rgb;

	vec3 spillover = max(vec3(0.0, 0.0, 0.0), out_color_raw - vec3(1.0, 1.0, 1.0));
	out_color_raw.r += spillover.g / 2.0 + spillover.b / 2.0;
	out_color_raw.g += spillover.r / 2.0 + spillover.b / 2.0;
	out_color_raw.b += spillover.r / 2.0 + spillover.g / 2.0;

	o_color = vec4(clamp(out_color_raw, 0.0, 1.0), 1.0);
}